def array(N1, N2=0,N3=0):   #■配列宣言
    if N2==0: return [0 for i in range(N1)]
    if N3==0: return [[0 for i in range(N2)]
                      for j in range(N1)]
    return[[[0 for i in range(N3)]for j in range(N2)]
           for j in range(N1)]
def genTabName(SData,B,ID):#■Gini係数計算用の表作成
    N=len(B); A=array(N+1,3);
    NX=len(SData);ND=len(SData[0])
    for i in range(NX):            #する／しないのカウント
        for k in range(N):
            if SData[i][ID]==B[k]:
                if SData[i][ND-1]=="する":A[k][0]+=1
                else:A[k][1]+=1
    for i in range(N): A[i][2]=A[i][0]+A[i][1]#横合計
    for k in range(3):
        for i in range(N):A[N][k]+=A[i][k]    #縦合計
    return A
def compGini(X,B,Debug):#■Gini係数計算（Debug=Trueで途中経過表示）
    N2=len(X)-1;N1=len(X[0])-1;C=array(N2)
    if Debug: print("\n■Gini係数")
    for i in range(N2):
        p=1;V=X[i][N1]
        if Debug: S="1"
        for j in range(N1):
            p-=(X[i][j]/V)**2
            if Debug:S+="-("+str(X[i][j])+"/"+str(V)+")^2"
        if Debug:print(B[i]+" : "+S+"="+str(p))
        C[i]=p
    V=X[N2][N1];p=0
    if Debug: S="全体:"; SS=""
    for i in range(N2):
        p+=C[i]*X[i][N1]/V;
        if Debug:
            S+=SS+ str(C[i])+"*"+str(X[i][N1])+"/"+str(V)
            SS="+"
    if Debug:print(S+"="+str(p))
    return p
def copyDT(SDL,ID):#■データ・コピー
    N=len(SDL);X=array(N-1)
    for i in range(N):
        if i<ID: X[i]=SDL[i]
        elif i>ID:X[i-1]=SDL[i]
    return X
def nonList(LST,DT):#■リストにないことをチェック
    for i in range(len(LST)):
        if LST[i]==DT: return False
    return True
def genList(SData,ID):#■表内の値のリストを作成
    B=[];
    for i in range(len(SData)):
        if nonList(B,SData[i][ID]):B.append(SData[i][ID])
    return B
def seperate(SData,ID):#■IDで示される条件で表を分割
    NS=len(SData); B=genList(SData,ID)
    N=len(B); X=[]
    for i in range(N): X.append([])
    for i in range(N):
        for j in range(NS):
            if SData[j][ID]==B[i]:
                X[i].append(copyDT(SData[j],ID))
    return [B,X]
def repNum(SData):#■温度と湿度の数値を高/低のデータに変える
    N1=len(SData);N2=len(SData[0]);X=array(N1,N2)
    for i in range(N1):
        for j in range(N2):
            if j==1:
                if SData[i][j]>=25:X[i][j]="高"
                else              :X[i][j]="低"
            elif j==2:
                if SData[i][j]>=75:X[i][j]="高"
                else              :X[i][j]="低"
            else: X[i][j]=SData[i][j]
    return X
def countYN(SData):#■する／しないのカウント
    N=len(SData);ID=len(SData[0])-1;CN=array(2)
    for i in range(N):
        if SData[i][ID]=="する":CN[0]+=1
        else:                   CN[1]+=1
    return CN
def genGiniTableOnly(IData,SData,ID):#■Gini計算用の表作成
    B=genList(SData,ID);X=genTabName(SData,B,ID)
    return X
def genGiniTable(IData,SData,ID,Debug=False):#■Gini係数を計算(表作成を含む)
    X=genGiniTableOnly(IData,SData,ID)
    B=genList(SData,ID);X=genTabName(SData,B,ID)
    if Debug:printGiniTab(IData[ID],B,X)
    NX=len(X)-1;NY=len(X[0])-1
    if X[NX][NY]==0:return 999999
    return compGini(X,B,Debug)
def selectByGini(IData,SData):#■Gini係数による条件の選択
    N=len(IData)-1      # (Gini係数最小値の条件を選ぶ)
    if N<2:return [0,[]]
    minG=99999999;ID=0;G=[]
    for i in range(N):
        Gini=genGiniTable(IData,SData,i)
        G.append([IData[i],Gini])#表示用に計算結果を残す
        if Gini<minG:minG=Gini;ID=i
    return [ID,G]   
def deleteID(IData,ID):#■見出しリストから条件を消す
    R=[]
    for i in range(len(IData)):
        if i !=ID:R.append(IData[i])
    return R
def scanTable(BSTR,IData,SData,N,Mode):#■テーブル・スキャンによる木構造化
    CN=countYN(SData);ID=len(SData[0])-1
    if ID==0 or CN[0]==0 or CN[1]==0:
        print("　"*N+BSTR+str(CN))
        return ["",CN]
    if Mode:#Gimi係数を考慮する場合
        SBG=selectByGini(IData,SData)
        selectID=SBG[0]
    else: SBG=[0,[]];selectID=0#Gimi係数を考慮しない場合
    print("　"*N+BSTR+str(CN)+IData[selectID]+strGini(SBG[1]))
    nextID=deleteID(IData,selectID)
    sepDT=seperate(SData,selectID)
    BDT=sepDT[0];sepDT=sepDT[1];NS=len(sepDT)
    R=[]
    for i in range(NS):
        RD=scanTable(BDT[i],nextID,sepDT[i],N+4,Mode)
        R.append([IData[selectID],BDT[i],RD])
    return R
def tableToTree(IData,NDT,Mode):
    print("\n■表を学習する")
    return scanTable(" ",IData, NDT,0,Mode)
#--------------以下，表示用------------------------
def strNumber(V):#■半角と全角が混在すると桁位置がずれるので用意
    numCHR=["０","１","２","３","４","５","６","７","８","９"]
    V3=int(V/100);V1=V % 10; V2=int((V-V3*100-V1)/10)
    if V3==0 and V2==0:return "　　"+numCHR[V1]
    if V3==0 : return "　"+numCHR[V2]+numCHR[V1]
    return numCHR[V3]+numCHR[V2]+numCHR[V1]
def strGini(SBG):#■各条件のGiniの値を文字列化する
    if SBG==[]:return ""
    S=" Gini(";SS=""
    for i in range(len(SBG)):
        S+=SS+SBG[i][0]+":%7.4f"%SBG[i][1];SS=", "
    return S+")"
def printData(IData,SData):#■データ表示
    S="\n　"                       #見出し表示
    for Item in IData:S+=Item+"　"
    print(S);print("―"*18)
    for i in range(len(SData)):    #データ部表示
        S=""
        for j in range(len(SData[i])):
            if type(SData[i][j]) is int:
                S+=strNumber(SData[i][j])
            else: S+="　"+SData[i][j]+"　"
        print(S)
def brScan(S):#■全角数字列の先頭空白削除
    if S[0]=="　" and S[1]=="　": return S[2]
    if S[0]=="　": return S[1]+S[2]
    return S
def printGiniTab(Title,B,X):#■Gini係数計算用の表の表示
    N=len(B);print()
    print(Title+"　"*(8-len(Title)),"する しない 合計")
    print("-"*35)
    for i in range(N+1):
        if i==N: S="　合計  　　　"
        else: S="　"+B[i]+"　"*(6-len(B[i]))        
        for k in range(len(X[i])):
            S+=strNumber(X[i][k])
        print(S)
def printR(R,S):#■得られた結果の判定順序表示
    #print(R)
    if R[0]=="":
        print(S+"　"+str(R[1]))
        return
    for i in range(len(R)):
        #print(" "*N+R[i][0]+"="+R[i][1])
        if i==0:
            printR(R[i][2],S+"　"+R[i][0]+"＝"+R[i][1])
        else:
            printR(R[i][2],"　"*len(S)+"　"+R[i][0]+"＝"+R[i][1])
           
def printTree(R):#■得られた結果の判定順序表示(メイン）
    print("\n■学習結果の条件判定")
    printR(R,"")
